# [134. 加油站｜刷题打卡](https://github.com/danygitgit/document-library)

> create by **db** on **2021-3-2 22:48:10**  
> Recently revised in **2021-3-2 23:38:36**

 **闲时要有吃紧的心思，忙时要有悠闲的趣味**

> 原题链接[134. 加油站](https://leetcode-cn.com/problems/gas-station)
<a id="catalog">目录</a>

- [题目描述](#preface)
- [思路分析](#main-body)
- [AC 代码](#main-body2)
- [总结](#summary)

# <a  id="preface">题目描述</a>

> [返回目录](#catalog)

&emsp;在一条环路上有 N 个加油站，其中第 i 个加油站有汽油 gas[i] 升。

&emsp;你有一辆油箱容量无限的的汽车，从第 i 个加油站开往第 i+1 个加油站需要消耗汽油 cost[i] 升。你从其中的一个加油站出发，开始时油箱为空。

&emsp;如果你可以绕环路行驶一周，则返回出发时加油站的编号，否则返回 -1。

说明: 

- 如果题目有解，该答案即为唯一答案。
- 输入数组均为非空数组，且长度相同。
- 输入数组中的元素均为非负数。
示例 1:
```
输入: 
gas  = [1,2,3,4,5]
cost = [3,4,5,1,2]

输出: 3

解释:
从 3 号加油站(索引为 3 处)出发，可获得 4 升汽油。此时油箱有 = 0 + 4 = 4 升汽油
开往 4 号加油站，此时油箱有 4 - 1 + 5 = 8 升汽油
开往 0 号加油站，此时油箱有 8 - 2 + 1 = 7 升汽油
开往 1 号加油站，此时油箱有 7 - 3 + 2 = 6 升汽油
开往 2 号加油站，此时油箱有 6 - 4 + 3 = 5 升汽油
开往 3 号加油站，你需要消耗 5 升汽油，正好足够你返回到 3 号加油站。
因此，3 可为起始索引。
```

示例 2:
```
输入: 
gas  = [2,3,4]
cost = [3,4,3]

输出: -1

解释:
你不能从 0 号或 1 号加油站出发，因为没有足够的汽油可以让你行驶到下一个加油站。
我们从 2 号加油站出发，可以获得 4 升汽油。 此时油箱有 = 0 + 4 = 4 升汽油
开往 0 号加油站，此时油箱有 4 - 3 + 2 = 3 升汽油
开往 1 号加油站，此时油箱有 3 - 3 + 3 = 3 升汽油
你无法返回 2 号加油站，因为返程需要消耗 4 升汽油，但是你的油箱只有 3 升汽油。
因此，无论怎样，你都不可能绕环路行驶一周。
```

# <a  id="main-body">思路分析</a>

&emsp;这是一道简单题，不过对我们这些算法小白来说是个认识**链表**这一数据结构的不错选择。

&emsp;那什么是链表呢？我觉得小灰算法讲的不错。

![](../../public-repertory/img/算法/链表1.jpg)
![](../../public-repertory/img/算法/链表2.jpg)

## 思路一：

&emsp;这就让我想到了位运算——异或（^）。

**tips:** 按位“异或”运算符说明

> `^` 运算符查看两个表达式的二进制表示法的值，并执行按位异或。该操作的结果如下所示：

```
0101 (expression1)
1100 (expression2)
----
1001 (结果)
```

&emsp;当且仅当只有一个表达式的某位上为 1 时，结果的该位才为 1。否则结果的该位为 0。即两个相等的数相加为0。

## 思路二：

&emsp;虽然不能使用辅助数组，但是我们可以一个数组正反两头查啊。

&emsp;出现两次的元素肯定不在同一位置，出现一次的别管哪头查都在同一位置。找出他来就好了。

# <a  id="main-body2">AC 代码</a>

## 题解一：异或运算

```js
/**
 * @param {number[]} nums
 * @return {number}
 */
var singleNumber = function(nums) {
    let res = 0
    nums.forEach(el=> {
      res ^= el
    })
    return res
};
```
## 题解二：正反查找

```js
/**
 * @param {number[]} nums
 * @return {number}
 */
var singleNumber = function(nums) {
    let res = 0
    nums.forEach(el=> {
      if(nums.indexOf(el) === nums.lastIndexOf(el)){
        res =  el
      }
    })
    return res
};
```
# <a  id="summary">总结</a>

> [返回目录](#catalog)
> 
&emsp;很简单的一道题，柿子先挑软的捏……

&emsp;三月你好，春暖花开。加油！

&emsp;本文正在参与「掘金 2021 春招闯关活动」, 点击查看 [活动详情](https://juejin.cn/post/6933147477399109640)

**后记：Hello 小伙伴们，如果觉得本文还不错，记得点个赞或者给个 star，你们的赞和 star 是我编写更多更丰富文章的动力！[GitHub 地址](https://github.com/danygitgit/document-library)**

# 文档协议

> <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/"><img alt="知识共享许可协议" style="border-width:0" src="https://user-gold-cdn.xitu.io/2018/12/23/167d9537f3e29c99?w=88&h=31&f=png&s=1888" /></a><br /><a xmlns:dct="http://purl.org/dc/terms/" property="dct:title">**db** 的文档库</a> 由 <a xmlns:cc="http://creativecommons.org/ns#" href="db" property="cc:attributionName" rel="cc:attributionURL">db</a> 采用 <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">知识共享 署名-非商业性使用-相同方式共享 4.0 国际 许可协议</a>进行许可。<br />基于<a xmlns:dct="http://purl.org/dc/terms/" href="https://github.com/danygitgit" rel="dct:source">https://github.com/danygitgit</a>上的作品创作。<br />本许可协议授权之外的使用权限可以从 <a xmlns:cc="http://creativecommons.org/ns#" href="https://creativecommons.org/licenses/by-nc-sa/2.5/cn/" rel="cc:morePermissions">https://creativecommons.org/licenses/by-nc-sa/2.5/cn/</a> 处获得。
