# [125. 验证回文串｜刷题打卡](https://github.com/danygitgit/document-library)

> create by **db** on **2021-3-11 20:10:12**  
> Recently revised in **2021-3-11 20:17:16**

**闲时要有吃紧的心思，忙时要有悠闲的趣味**

> 原题链接[125. 验证回文串](https://leetcode-cn.com/problems/valid-palindrome) > <a id="catalog">目录</a>

- [题目描述](#preface)
- [思路分析](#main-body)
- [AC 代码](#main-body2)
- [总结](#summary)

# <a  id="preface">题目描述</a>

> [返回目录](#catalog)

&emsp;给定一个字符串，验证它是否是回文串，只考虑字母和数字字符，可以忽略字母的大小写。

&emsp;说明：本题中，我们将空字符串定义为有效的回文串。

示例 1:

```
输入: "A man, a plan, a canal: Panama"
输出: true
输出: true
```

示例 2:

```
输入: "race a car"
输出: false
```

# <a  id="main-body">思路分析</a>

&emsp;说起回文，想到一首回文诗。苏东坡的《菩萨蛮·回文夏闺怨》：

```
柳庭风静人眠昼，昼眠人静风庭柳。

香汗薄衫凉，凉衫薄汗香。

手红冰碗藕，藕碗冰红手。

郎笑藕丝长，长丝藕笑郎。
```

## 思路一：翻转对比

&emsp;所谓会问，就是正反一样。只考虑字母和数字且不区分大小写，我们就取出字符串中的有效内容，翻转对比就好。

## 思路二：双指针对比

&emsp;前后两个指针，取出字符串中的有效内容，一一对比。

# <a  id="main-body2">AC 代码</a>

## 题解一：翻转对比

```js
/**
 * @param {string} s
 * @return {boolean}
 */
var isPalindrome = function (s) {
  let s1 = s.replace(/[^0-9a-zA-Z]/g, '').toLowerCase()
  let s2 = s1.split('').reverse().join('')
  return s1 === s2
}
```

## 题解二：双指针对比

```js
/**
 * @param {string} s
 * @return {boolean}
 */
var isPalindrome = function (s) {
  // 双指针对比
  s = s.replace(/[^0-9a-zA-Z]/g, '').toLowerCase()
  let left = 0
  let right = s.length - 1

  while (left < right) {
    if (s[left] != s[right]) {
      return false
    }
    left++
    right--
  }
  return true
}
```

# <a  id="summary">总结</a>

> [返回目录](#catalog)
>
> &emsp;很简单的一道题，柿子先挑软的捏……

&emsp;三月你好，春暖花开。加油！

&emsp;本文正在参与「掘金 2021 春招闯关活动」, 点击查看 [活动详情](https://juejin.cn/post/6933147477399109640)

**后记：Hello 小伙伴们，如果觉得本文还不错，记得点个赞或者给个 star，你们的赞和 star 是我编写更多更丰富文章的动力！[GitHub 地址](https://github.com/danygitgit/document-library)**

# 文档协议

> <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/"><img alt="知识共享许可协议" style="border-width:0" src="https://user-gold-cdn.xitu.io/2018/12/23/167d9537f3e29c99?w=88&h=31&f=png&s=1888" /></a><br /><a xmlns:dct="http://purl.org/dc/terms/" property="dct:title">**db** 的文档库</a> 由 <a xmlns:cc="http://creativecommons.org/ns#" href="db" property="cc:attributionName" rel="cc:attributionURL">db</a> 采用 <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">知识共享 署名-非商业性使用-相同方式共享 4.0 国际 许可协议</a>进行许可。<br />基于<a xmlns:dct="http://purl.org/dc/terms/" href="https://github.com/danygitgit" rel="dct:source">https://github.com/danygitgit</a>上的作品创作。<br />本许可协议授权之外的使用权限可以从 <a xmlns:cc="http://creativecommons.org/ns#" href="https://creativecommons.org/licenses/by-nc-sa/2.5/cn/" rel="cc:morePermissions">https://creativecommons.org/licenses/by-nc-sa/2.5/cn/</a> 处获得。
