# [448. 找到所有数组中消失的数字｜刷题打卡](https://github.com/danygitgit/document-library)

> create by **db** on **2021-3-6 16:46:24**  
> Recently revised in **2021-3-6 16:56:30**

**闲时要有吃紧的心思，忙时要有悠闲的趣味**

> 原题链接[448. 找到所有数组中消失的数字](https://leetcode-cn.com/problems/find-all-numbers-disappeared-in-an-array)

<a id="catalog">目录</a>

- [题目描述](#preface)
- [思路分析](#main-body)
- [AC 代码](#main-body2)
- [总结](#summary)

# <a  id="preface">题目描述</a>

> [返回目录](#catalog)

&emsp;给定一个范围在   1 ≤ a[i] ≤ n ( n = 数组大小 ) 的 整型数组，数组中的元素一些出现了两次，另一些只出现一次。

&emsp;找到所有在 [1, n] 范围之间没有出现在数组中的数字。

&emsp;您能在不使用额外空间且时间复杂度为 O(n)的情况下完成这个任务吗? 你可以假定返回的数组不算在额外空间内。

示例:

```
输入:
[4,3,2,7,8,2,3,1]

输出:
[5,6]
```

# <a  id="main-body">思路分析</a>

## 思路一：遍历查找

&emsp;已知数组中元素范围为 1-n，那么从 1 遍历至 n，依次查找元素是否存在，不存在的放入新数组。时间复杂度 O(n)，空间复杂度 O(1)

## 思路二：数组置换

&emsp;使用数组的下标来标记数字的出现于否，出现过就标记为负值。通过一遍遍历即可标记出全部已经出现的数字（已置换为负值）

&emsp;然后再遍历一次，数组中为正值的元素所在的下标+1 就是未出现过的数字。

&emsp;

# <a  id="main-body2">AC 代码</a>

## 题解一：遍历查找

```js
/**
 * @param {number[]} nums
 * @return {number[]}
 */
var findDisappearedNumbers = function (nums) {
  // 声明新数组
  let arr = []
  // 遍历1至数组长度之间的数字
  for (let i = 1; i <= nums.length; i++) {
    // 若果当前数组没有则加入新数组
    if (nums.indexOf(i) === -1) {
      arr.push(i)
    }
  }
  return arr
}
```

## 题解二：数组置换

```js
// 输入[4,3,2,7,8,2,3,1]
// 数组元素范围为 1-n，n 为数组长度，0-(n-1)为数字元素下标
// 将出现的 Math.abs(nums[i])-1 下标对应的元素变为负的，说明数组中有 nums[i]这个数
// 而那些大于 0 的数组元素的(下标+1)是数组中消失的数
for (let i=0; i<nums.length; i++){
let newIndex = Math.abs(nums[i]) - 1
if (nums[newIndex] > 0) {
nums[newIndex] \*= -1
}
}
// 遍历完成后，数组变为[-4,-3,-2,-7,8,2,-3,-1]

```

```js
/**
 * @param {number[]} nums
 * @return {number[]}
 */
var findDisappearedNumbers = function (nums) {
  // 声明新数组
  let arr = []
  // 遍历原数组
  for (let i of nums) {
    // 将下标为i的元素置换为负值
    // 使用Math.abs()确保绝对值为正数
    nums[Math.abs(i) - 1] = -Math.abs(nums[Math.abs(i) - 1])
  }

  for (let j in nums) {
    // 没出现的元素(大于0)等于下标+1
    if (nums[j] > 0) {
      arr.push(j + 1)
    }
  }

  return arr
}
```

# <a  id="summary">总结</a>

> [返回目录](#catalog)

> &emsp;菜狗只配捏软柿子……

&emsp;明天去看樱花喽！

&emsp;本文正在参与「掘金 2021 春招闯关活动」, 点击查看 [活动详情](https://juejin.cn/post/6933147477399109640)

**后记：Hello 小伙伴们，如果觉得本文还不错，记得点个赞或者给个 star，你们的赞和 star 是我编写更多更丰富文章的动力！[GitHub 地址](https://github.com/danygitgit/document-library)**

# 文档协议

> <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/"><img alt="知识共享许可协议" style="border-width:0" src="https://user-gold-cdn.xitu.io/2018/12/23/167d9537f3e29c99?w=88&h=31&f=png&s=1888" /></a><br /><a xmlns:dct="http://purl.org/dc/terms/" property="dct:title">**db** 的文档库</a> 由 <a xmlns:cc="http://creativecommons.org/ns#" href="db" property="cc:attributionName" rel="cc:attributionURL">db</a> 采用 <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">知识共享 署名-非商业性使用-相同方式共享 4.0 国际 许可协议</a>进行许可。<br />基于<a xmlns:dct="http://purl.org/dc/terms/" href="https://github.com/danygitgit" rel="dct:source">https://github.com/danygitgit</a>上的作品创作。<br />本许可协议授权之外的使用权限可以从 <a xmlns:cc="http://creativecommons.org/ns#" href="https://creativecommons.org/licenses/by-nc-sa/2.5/cn/" rel="cc:morePermissions">https://creativecommons.org/licenses/by-nc-sa/2.5/cn/</a> 处获得。
