# [70. 爬楼梯｜刷题打卡](https://github.com/danygitgit/document-library)

> create by **db** on **2021-3-11 19:00:47**  
> Recently revised in **2021-3-11 19:13:53**

**闲时要有吃紧的心思，忙时要有悠闲的趣味**

> 原题链接[70. 爬楼梯](https://leetcode-cn.com/problems/climbing-stairs/) > <a id="catalog">目录</a>

- [题目描述](#preface)
- [思路分析](#main-body)
- [AC 代码](#main-body2)
- [总结](#summary)

# <a  id="preface">题目描述</a>

> [返回目录](#catalog)

&emsp;假设你正在爬楼梯。需要 n 阶你才能到达楼顶。

&emsp;每次你可以爬 1 或 2 个台阶。你有多少种不同的方法可以爬到楼顶呢？

&emsp;注意：给定 n 是一个正整数。

示例 1：

```
输入： 2
输出： 2
解释： 有两种方法可以爬到楼顶。
1.  1 阶 + 1 阶
2.  2 阶
示例 2：

输入： 3
输出： 3
解释： 有三种方法可以爬到楼顶。
1.  1 阶 + 1 阶 + 1 阶
2.  1 阶 + 2 阶
3.  2 阶 + 1 阶
```

# <a  id="main-body">思路分析</a>

&emsp;是不是觉得这道题似曾相识？

&emsp;例如第 N 阶的楼梯，有几种方式能够跳上来呢？只有(n - 1)和(n - 2)阶楼梯能跳上来。

&emsp;依次类推，每一阶楼梯只有其(n - 1)和(n - 2)能跳上来，除了 1 阶和 2 阶楼梯。

> fn(n) = fn(n-1) + fn(n-2)

&emsp;没错，这就是斐波那契数列。

&emsp;我是没办法吧斐波那契讲出花来了，有需要可以看这个[超棒题解](https://leetcode-cn.com/problems/climbing-stairs/solution/wo-shi-yi-zhi-xiao-qing-wa-by-belinda/#comment)

## 思路一：递归

&emsp;说到斐波那契，最经典解法的要数递归了。但是会超时……

## 思路二：滚动数组

就是这样的：

![](https://assets.leetcode-cn.com/solution-static/70/70_fig1.gif)

# <a  id="main-body2">AC 代码</a>

## 递归

```js
/**
 * @param {number} n
 * @return {number}
 */
var climbStairs = function (n) {
  if (n === 1) return 1
  if (n === 2) return 2
  return climbStairs(n - 1) + climbStairs(n - 2)
}
```

## 题解二：滚动数组

```js
/**
 * @param {number} n
 * @return {number}
 */
var climbStairs = function (n) {
  let p = 0,
    q = 0,
    r = 1
  for (let i = 1; i <= n; ++i) {
    p = q
    q = r
    r = p + q
  }
  return r
}
```

# <a  id="summary">总结</a>

> [返回目录](#catalog)

&emsp;三月你好，春暖花开。加油！

&emsp;本文正在参与「掘金 2021 春招闯关活动」, 点击查看 [活动详情](https://juejin.cn/post/6933147477399109640)

**后记：Hello 小伙伴们，如果觉得本文还不错，记得点个赞或者给个 star，你们的赞和 star 是我编写更多更丰富文章的动力！[GitHub 地址](https://github.com/danygitgit/document-library)**

# 文档协议

> <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/"><img alt="知识共享许可协议" style="border-width:0" src="https://user-gold-cdn.xitu.io/2018/12/23/167d9537f3e29c99?w=88&h=31&f=png&s=1888" /></a><br /><a xmlns:dct="http://purl.org/dc/terms/" property="dct:title">**db** 的文档库</a> 由 <a xmlns:cc="http://creativecommons.org/ns#" href="db" property="cc:attributionName" rel="cc:attributionURL">db</a> 采用 <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">知识共享 署名-非商业性使用-相同方式共享 4.0 国际 许可协议</a>进行许可。<br />基于<a xmlns:dct="http://purl.org/dc/terms/" href="https://github.com/danygitgit" rel="dct:source">https://github.com/danygitgit</a>上的作品创作。<br />本许可协议授权之外的使用权限可以从 <a xmlns:cc="http://creativecommons.org/ns#" href="https://creativecommons.org/licenses/by-nc-sa/2.5/cn/" rel="cc:morePermissions">https://creativecommons.org/licenses/by-nc-sa/2.5/cn/</a> 处获得。
