# [11. 盛最多水的容器｜刷题打卡](https://github.com/danygitgit/document-library)

> create by **db** on **2021-3-11 16:10:51**  
> Recently revised in **2021-3-11 16:22:59**

**闲时要有吃紧的心思，忙时要有悠闲的趣味**

> 原题链接[11. 盛最多水的容器](https://leetcode-cn.com/problems/container-with-most-water/) > <a id="catalog">目录</a>

- [题目描述](#preface)
- [思路分析](#main-body)
- [AC 代码](#main-body2)
- [总结](#summary)

# <a  id="preface">题目描述</a>

> [返回目录](#catalog)

&emsp;给你 n 个非负整数 a1，a2，...，an，每个数代表坐标中的一个点  (i, ai) 。在坐标内画 n 条垂直线，垂直线 i  的两个端点分别为  (i, ai) 和 (i, 0) 。找出其中的两条线，使得它们与  x  轴共同构成的容器可以容纳最多的水。

&emsp;说明：你不能倾斜容器。

示例 1：
![](https://aliyun-lc-upload.oss-cn-hangzhou.aliyuncs.com/aliyun-lc-upload/uploads/2018/07/25/question_11.jpg)

```

输入：[1,8,6,2,5,4,8,3,7]
输出：49
解释：图中垂直线代表输入数组 [1,8,6,2,5,4,8,3,7]。在此情况下，容器能够容纳水（表示为蓝色部分）的最大值为 49。
```

示例 2：

```
输入：height = [1,1]
输出：1
```

示例 3：

```
输入：height = [4,3,2,1,4]
输出：16
```

示例 4：

```
输入：height = [1,2,1]
输出：2
```

提示：

- n = height.length
- 2 <= n <= 3 \* 104
- 0 <= height[i] <= 3 \* 104

# <a  id="main-body">思路分析</a>


## 思路一：暴力遍历

&emsp;逐个尝试每两条 bar 的组合,求出面积,得到最大的组合。

- 时间复杂度: O(n^2),循环运行 n(n-1)/2 次
- 空间复杂度: O(1),只使用了常数个变量

**tips:**

&emsp;很遗憾，这个算法被 LeetCode 判为超时……

## 思路二：双指针循环

&emsp;使用**双指针**从两端向中心移动，每次移动较矮的那端以做其他的线段尝试，仍然取最大组合。

&emsp;循环一遍就可以了

- 时间复杂度:O(n)
- 空间复杂度:O(1)

# <a  id="main-body2">AC 代码</a>

## 题解一：暴力遍历

```js
/**
 * @param {number[]} height
 * @return {number}
 */
var maxArea = function (height) {
  if (height.length <= 1) {
    return 0
  }
  let maxArea = 0
  let area = 0
  let minBar = 0
  for (let i = 0; i < height.length; i++) {
    for (let j = i + 1; j < height.length; j++) {
      minBar = Math.min(height[i], height[j])
      area = minBar * (j - i)
      maxArea = Math.max(maxArea, area)
    }
  }
  return maxArea
}
```

## 题解二：双指针循环

```js
/**
 * @param {number[]} height
 * @return {number}
 */
var maxArea = function (height) {
  let left = 0
  let right = height.length - 1
  let result = 0
  while (left < right) {
    result = Math.max(
      result,
      (right - left) * Math.min(height[left], height[right])
    )
    if (height[left] < height[right]) {
      left++
    } else {
      right--
    }
  }
  return result
}
```

# <a  id="summary">总结</a>

> [返回目录](#catalog)

&emsp;三月你好，春暖花开。加油！

&emsp;本文正在参与「掘金 2021 春招闯关活动」, 点击查看 [活动详情](https://juejin.cn/post/6933147477399109640)

**后记：Hello 小伙伴们，如果觉得本文还不错，记得点个赞或者给个 star，你们的赞和 star 是我编写更多更丰富文章的动力！[GitHub 地址](https://github.com/danygitgit/document-library)**

# 文档协议

> <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/"><img alt="知识共享许可协议" style="border-width:0" src="https://user-gold-cdn.xitu.io/2018/12/23/167d9537f3e29c99?w=88&h=31&f=png&s=1888" /></a><br /><a xmlns:dct="http://purl.org/dc/terms/" property="dct:title">**db** 的文档库</a> 由 <a xmlns:cc="http://creativecommons.org/ns#" href="db" property="cc:attributionName" rel="cc:attributionURL">db</a> 采用 <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">知识共享 署名-非商业性使用-相同方式共享 4.0 国际 许可协议</a>进行许可。<br />基于<a xmlns:dct="http://purl.org/dc/terms/" href="https://github.com/danygitgit" rel="dct:source">https://github.com/danygitgit</a>上的作品创作。<br />本许可协议授权之外的使用权限可以从 <a xmlns:cc="http://creativecommons.org/ns#" href="https://creativecommons.org/licenses/by-nc-sa/2.5/cn/" rel="cc:morePermissions">https://creativecommons.org/licenses/by-nc-sa/2.5/cn/</a> 处获得。
