@[常用正则表达式集锦](https://github.com/danygitgit/document-library/blob/master/other-library/%E6%AD%A3%E5%88%99/%E6%AD%A3%E5%88%99%E8%A1%A8%E8%BE%BE%E5%BC%8F%E9%9B%86%E9%94%A6%20.md)  

> create by **db** on **2019-5-13 09:45:24**   
> Recently revised in **2019-6-21 11:30:54**  

&emsp;**Hello 小伙伴们，如果觉得本文还不错，麻烦点个赞或者给个 star，你们的赞和 star 是我前进的动力！[GitHub 地址](https://github.com/danygitgit/document-library/blob/master/other-library/%E6%AD%A3%E5%88%99/%E6%AD%A3%E5%88%99%E8%A1%A8%E8%BE%BE%E5%BC%8F%E9%9B%86%E9%94%A6%20.md)**  


# 前言  

> I hear and I fogorget.  

> I see and I remember.  

> I do and I understand.  

&emsp;作为一个前端码农，总是避免不了使用正则来检验数据或者截取字符串。然而对于这些“火星文”总是记不牢靠。因此，把工作中常用的一些正则表达式整理存档，给自己留个底，也给朋友们做个参考。

&emsp;此文档不做正则科普详解，仅供查阅。如果不是太清楚正则是啥，烦请移步参考文档。

&emsp;参考文档：

- [js中的正则表达式入门 | 博客园-陈水水的个人博客](https://www.cnblogs.com/chenmeng0818/p/6370819.html)

- [正则表达式不要背 | 掘金-scq000](https://juejin.im/post/5cdcd42551882568651554e6#comment)

# 正文


## 正则表达式常用操作符
| 操作符 | 说明                       | 实例                                         |
| ------ | -------------------------- | -------------------------------------------- |
| .      | 表示任何单个字符           |
| [ ]    | 字符集，对单个字符给出范围 | `[abc]`表示 a、b、c,[a-z]表示 a-z 的单个字符 |
[^ ]	|非字符集，对单个字符给出排除范围|`[^abc]`表示非a或b或c的单个字符|
|_ | 前一个字符零次或无限次扩展| `abc_`表示 ab、abc、abcc、abccc 等| | + | 前一个字符 1 次或无限次扩展|`abc+`表示 abc、abcc、abccc 等| 
|`|`|左右表达式的任意一个|`abc|def`表示 abc、def| 
|$ | 匹配字符串结尾|`abc$`表示 abc 且在一个字符串结尾| 
|( )| 分组标记内部只能使用|`(abc)`表示 abc,`(abc|def)`表示 abc、def| 
|\D| 非数字|
|\d| 数字，等价于0-9 | 
|\S | 可见字符| 
|\s | 空白字符| 
|\W | 非单词字符|
|\w | 单词字符，等价于[a-z0-9A-Z_]| 
|^ |匹配字符串开头 |`^abc`表示 abc 且在一个字符串的开头| 
|{m,n} | 扩展前一个字符 m 到 n 次|`ab{1,2}c`表示 abc、abbc| 
|{m} | 扩展前一个字符 m 次 |`ab{2}c`表示 abbc| 
|？| 前一个字符 0 次或 1 次扩展|`abc?` 表示 ab、abc|
undefined

## 常用正则表达式集锦

### 一、校验数字的表达式

 数字：`^[0-9]*$`

n位的数字：`^d{n}$`

至少n位的数字：`^d{n,}$`

m-n位的数字：`^d{m,n}$`

零和非零开头的数字：`^(0|[1-9][0-9]*)$`

非零开头的最多带两位小数的数字：`^([1-9][0-9]*)+(.[0-9]{1,2})?$`

带1-2位小数的正数或负数：`^(-)?d+(.d{1,2})?$`

正数、负数、和小数：`^(-|+)?d+(.d+)?$`

有两位小数的正实数：`^[0-9]+(.[0-9]{2})?$`

有1~3位小数的正实数：`^[0-9]+(.[0-9]{1,3})?$`

非零的正整数：`^[1-9]d*$` 或 `^([1-9][0-9]*){1,3}$` 或 `^+?[1-9][0-9]*$`

非零的负整数：`^-[1-9][]0-9"*$` 或 `^-[1-9]d*$`

非负整数：`^d+$` 或 `^[1-9]d*|0$`

非正整数：`^-[1-9]d*|0$` 或 `^((-d+)|(0+))$`

非负浮点数：`^d+(.d+)?$` 或 `^[1-9]d*.d*|0.d*[1-9]d*|0?.0+|0$`

非正浮点数：`^((-d+(.d+)?)|(0+(.0+)?))$` 或 `^(-([1-9]d*.d*|0.d*[1-9]d*))|0?.0+|0$`

正浮点数：`^[1-9]d*.d*|0.d*[1-9]d*$` 或 `^(([0-9]+.[0-9]*[1-9][0-9]*)|([0-9]*[1-9][0-9]*.[0-9]+)|([0-9]*[1-9][0-9]*))$`

负浮点数：`^-([1-9]d*.d*|0.d*[1-9]d*)$` 或 `^(-(([0-9]+.[0-9]*[1-9][0-9]*)|([0-9]*[1-9][0-9]*.[0-9]+)|([0-9]*[1-9][0-9]*)))$`

浮点数：`^(-?d+)(.d+)?$` 或 `^-?([1-9]d*.d*|0.d*[1-9]d*|0?.0+|0)$`

### 二、校验字符的表达式

汉字：`^[\u4e00-\u9fa5]+$`

英文和数字：`^[A-Za-z0-9]+$` 或 `^[A-Za-z0-9]{4,40}$`

长度为3-20的所有字符：`^.{3,20}$`

由26个英文字母组成的字符串：`^[A-Za-z]+$`

由26个大写英文字母组成的字符串：`^[A-Z]+$`

由26个小写英文字母组成的字符串：`^[a-z]+$`

由数字和26个英文字母组成的字符串：`^[A-Za-z0-9]+$`

由数字、26个英文字母或者下划线组成的字符串：`^w+$` 或 `^w{3,20}$`

### 三、特殊需求表达式

去掉左右空格:
`str.replace(/(^\s*)|(\s*$)/g, '')`

去掉所有空格:
`str.replace(/\s+/g, '')`

密码需由8位以上大写字母、小写字母、数字及特殊符号组成: `/^(?=.*?[A-Z])(?=.*?[a-z])(?=.*?[0-9])(?=.*?[#?!.,@$%^&*-]).{8,}$/`

Email地址：`^w+([-+.]w+)*@w+([-.]w+)*.w+([-.]w+)*$`

域名：[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(/.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+/.?

InternetURL：[a-zA-z]+://[`^s]* 或 `^http://([w-]+.)+[w-]+(/[w-./?%&=]*)?$`

手机号码：`^(13[0-9]|14[5|7]|15[0|1|2|3|5|6|7|8|9]|18[0|1|2|3|5|6|7|8|9])d{8}$`

电话号码(“XXX-XXXXXXX”、”XXXX-XXXXXXXX”、”XXX-XXXXXXX”、”XXX-XXXXXXXX”、”XXXXXXX”和”XXXXXXXX)：`^((d{3,4}-)|d{3.4}-)?d{7,8}$`

国内电话号码`(0511-4405222、021-87888822)：d{3}-d{8}|d{4}-d{7}`

身份证号(15位、18位数字)：`^d{15}|d{18}$`

短身份证号码(数字、字母x结尾)：`^([0-9]){7,18}(x|X)?$` 或 `^d{8,18}|[0-9x]{8,18}|[0-9X]{8,18}?$`

帐号是否合法(字母开头，允许5-16字节，允许字母数字下划线)：`^[a-zA-Z][a-zA-Z0-9_]{4,15}$`

密码(以字母开头，长度在6~18之间，只能包含字母、数字和下划线)：`^[a-zA-Z]w{5,17}$`

强密码(必须包含大小写字母和数字的组合，不能使用特殊字符，长度在8-10之间)：`^(?=.*d)(?=.*[a-z])(?=.*[A-Z]).{8,10}$`

日期格式：`^d{4}-d{1,2}-d{1,2}`

一年的12个月(01～09和1～12)：`^(0?[1-9]|1[0-2])$`

一个月的31天(01～09和1～31)：`^((0?[1-9])|((1|2)[0-9])|30|31)$`
xml文件：`^([a-zA-Z]+-?)+[a-zA-Z0-9]+\.[x|X][m|M][l|L]$`


空白行的正则表达式：`s*` (可以用来删除空白行)

HTML标记的正则表达式：```<(S*?)[`^>]*>.*?</>|<.*? />``` (网上流传的版本太糟糕，上面这个也仅仅能部分，对于复杂的嵌套标记依旧无能为力)

首尾空白字符的正则表达式：`^s*|s*$`或(`^s*)|(s*$`) (可以用来删除行首行尾的空白字符(包括空格、制表符、换页符等等)，非常有用的表达式)

腾讯QQ号：`[1-9][0-9]{4,}` (腾讯QQ号从10000开始)

中国邮政编码：`[1-9]d{5}(?!d)` (中国邮政编码为6位数字)

IP地址：`d+.d+.d+.d+` (提取IP地址时有用)

IP地址：`((?:(?:25[0-5]|2[0-4]\d|[01]?\d?\d)\.){3}(?:25[0-5]|2[0-4]\d|[01]?\d?\d))`

### 钱的输入格式：

1. 有四种钱的表示形式我们可以接受:”10000.00” 和 “10,000.00”, 和没有 “分” 的 “10000” 和 “10,000”：`^[1-9][0-9]*$`

2. 这表示任意一个不以0开头的数字,但是,这也意味着一个字符”0”不通过,所以我们采用下面的形式：`^(0|[1-9][0-9]*)$`

3. 一个0或者一个不以0开头的数字.我们还可以允许开头有一个负号：`^(0|-?[1-9][0-9]*)$`

4. 这表示一个0或者一个可能为负的开头不为0的数字.让用户以0开头好了.把负号的也去掉,因为钱总不能是负的吧.下面我们要加的是说明可能的小数部分：`^[0-9]+(.[0-9]+)?$`

5. 必须说明的是,小数点后面至少应该有1位数,所以”10.”是不通过的,但是 “10” 和 “10.2” 是通过的：`^[0-9]+(.[0-9]{2})?$`

6. 这样我们规定小数点后面必须有两位,如果你认为太苛刻了,可以这样：`^[0-9]+(.[0-9]{1,2})?$`

7. 这样就允许用户只写一位小数.下面我们该考虑数字中的逗号了,我们可以这样：`^[0-9]{1,3}(,[0-9]{3})*(.[0-9]{1,2})?$`

8. 1到3个数字,后面跟着任意个 逗号+3个数字,逗号成为可选,而不是必须：`^([0-9]+|[0-9]{1,3}(,[0-9]{3})*)(.[0-9]{1,2})?$`

<!-- **备注：**

* 这就是最终结果了,别忘了”+”可以用”*”替代如果你觉得空字符串也可以接受的话(奇怪,为什么?)最后,别忘了在用函数时去掉去掉那个反斜杠,一般的错误都在这里 -->
### 正则表达式的简单使用方法

&emsp;以判断是否为中文字符为例，使用JavaScript的`test()`方法，写一个函数。

* `test()` 方法用于检测一个字符串是否匹配某个模式.如果字符串中有匹配的值返回 true ，否则返回 false。

```JavaScript
//是否含有中文（也包含日文和韩文）
function isChineseChar(str){   
   var reg = /[\u4E00-\u9FA5\uF900-\uFA2D]/;
   return reg.test(str);
}

isChineseChar('122') //false
isChineseChar('一二三') //true
```

## 总结  

&emsp;作为一只前端菜鸟，本篇文章旨在记录自己的学习心得，如有不足，还请多多指教。其中大部分是拷贝的，如有错误，慢慢用，慢慢改。谢谢大家。  

&emsp;路漫漫其修远兮，与诸君共勉。  

**后记：Hello 小伙伴们，如果觉得本文还不错，记得点个赞或者给个 star，你们的赞和 star 是我编写更多更丰富文章的动力！[GitHub 地址](https://github.com/danygitgit/document-library/blob/master/other-library/%E6%AD%A3%E5%88%99/%E6%AD%A3%E5%88%99%E8%A1%A8%E8%BE%BE%E5%BC%8F%E9%9B%86%E9%94%A6%20.md)**  

> <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/"><img alt="知识共享许可协议" style="border-width:0" src="https://user-gold-cdn.xitu.io/2018/12/23/167d9537f3e29c99?w=88&h=31&f=png&s=1888" /></a><br /><a xmlns:dct="http://purl.org/dc/terms/" property="dct:title">**db** 的文档库</a> 由 <a xmlns:cc="http://creativecommons.org/ns#" href="db" property="cc:attributionName" rel="cc:attributionURL">db</a> 采用 <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">知识共享 署名-非商业性使用-相同方式共享 4.0 国际 许可协议</a>进行许可。<br />基于<a xmlns:dct="http://purl.org/dc/terms/" href="https://github.com/danygitgit" rel="dct:source">https://github.com/danygitgit</a>上的作品创作。<br />本许可协议授权之外的使用权限可以从 <a xmlns:cc="http://creativecommons.org/ns#" href="https://creativecommons.org/licenses/by-nc-sa/2.5/cn/" rel="cc:morePermissions">https://creativecommons.org/licenses/by-nc-sa/2.5/cn/</a> 处获得。  