@[《凤凰项目》读书笔记](https://github.com/danygitgit/document-library)

> create by **db** on **2021-1-28 19:50:59**  
> Recently revised in **2021-1-28 23:11:38**
>
> **闲时要有吃紧的心思，忙时要有悠闲的趣味**

<a id="catalog">目录</a>

- [前言](#preface)

- [主观评价](#book-evaluate)

- [内容笔记](#content-notes)

- [个人心得](#my-learning)

- [总结](#summary)

# <a  id="preface">前言</a>

> [返回目录](#catalog)

&emsp;这是一本小说，以第一人称，类似日记的记叙方式，讲述了一位 IT 经理临危受命，在未来董事的帮助和自己“三步工作法”理念的支撑下，最终挽救了一家具有悠久历史的汽车配件制造商的故事。

# <a  id="book-evaluate">主观评价</a>

> [返回目录](#catalog)

&emsp;这是一本推销（或者说是鼓吹）**DevOps**的小说，其中小说部分我没有读完（其实写的一般……）。

&emsp;简要的看了一下第四章关于DevOps及三步工作法的内容，结合部分资料，大致了解了本书内容。

&emsp;作为一个绘图狗转程序猿的苦逼打工仔，这两种理论及实践我都有所接触。书中作者碰到的一些问题，相信很多人，在工作中，或多或少都会碰到这样的情况——无穷无尽的需求，无穷无尽的变更，很多时候得花大把的时间救火，却没时间找到问题原因，从根本上解决他。

&emsp;**DevOps**,字面上书开发运维一体化，是一组过程、方法与系统的统称，用于促进开发、技术运营和质量保障（QA）部门之间的沟通、协作与整合。本质上是敏捷开发结合精益生产的一套方法论（应用于组织管理层面）。

&emsp;从目标来看，DevOps就是让开发人员和运维人员更好地沟通合作，通过自动化流程来使得软件整体过程更加快捷和可靠。

&emsp;在DevOps的流程下，运维人员会在项目开发期间就介入到开发过程中，了解开发人员使用的系统架构和技术路线，从而制定适当的运维方案。而开发人员也会在运维的初期参与到系统部署中，并提供系统部署的优化建议。 

&emsp;DevOps贯穿于软件的全生命周期。设计 -> 开发  -> 测试 -> 部署，迅速迭代，频繁交付。

## 优点

-  以小说的形式，讲述了一个凌乱的无可救药的运维项目组是如何一步步达成最后高效且舒心的工作状态。比起相对枯燥的方法论来说，更易被大家接受。

## 缺点

&emsp;小说的翻译尚可，不过第四章讲三步工作法的时候，一些专业名词法医的很是生硬，而且连个解释也没有，差评！

## 适合人群：

&emsp;个人感觉，DevOps更适合大中型企业；而本书，适合对敏捷开发/精益生产/DevOps感兴趣，对企业项目管理工作感兴趣的同学阅读，类似项目经理、技术主管、CTO之类。

&emsp;至于对我一个码农来说，限于了解了一些新名词，增加了一些奇怪的知识，仅此而已。

## 推荐指数：★★★☆

# <a  id="content-notes">内容笔记</a>

### 本书结构

> [返回目录](#catalog)

&emsp;这本书一共有 4 个部分，其中前 3 部分是整本书的故事主线，第4 部分是理论部分，介绍 DevOps的发展历史，宣扬DevOps大法好。

&emsp;罗列一下故事主人公比尔担任 IT 运维副总裁期间的工作阶段：

- 阶段 1 - 无人遵守工作流程，项目一片混乱

- 阶段 2 - 试图终止混乱局面，重新规范流程

- 阶段 3 - 尝试解放约束点

- 阶段 4 - 专注核心项目，冻结额外项目，偿还债务

- 阶段 5 - 控制流入的工作项目

- 阶段 6 - 从企业顶层目标出发考虑问题，做真正有用的事

- 阶段 7 - 优化流程和工具，创建反馈回路，形成文化

# <a  id="my-learning)">个人心得</a>

## 约束点

**在瓶颈之外的任何地方进行的改进都是假象。**

那么要实现工作效率的提升就不应该是想到哪个环节能提升就提升那个环节，应该找出真正决定工作产出的约束点，提升约束点的工作能力，甚至想办法摆脱约束点的束缚。

## 四类工作

&emsp;小说最后总结了四项跟 IT 相关的工作类型，其实把这四种类型从 IT 工作抽离出来，每个部门或者个人的工作也能划分为以下四类：

1. **业务项目**：

- 这些通常是公司业务部门，比如产品研发部门或销售部门所提出的需求，比如新产品发布上线、为客户做实施、双十一这种大促活动的规划等等。这些工作通常具有一定的系统性，需要部门间通力合作。

2. **内部项目**：

- 运维部门内部围绕业务项目所实施的一些列基础设施研发，部署自动化、多环境构建、持续交付、监控报警等等。

3. **变更**：

- 根据其它部门申请，对运维组件进行变更操作，相对于业务项目，变更通常都会比较零散，比如加权限、开端口、开机器等等。对于变更，我们要维护好操作记录，做到有迹可寻。

4. **计划外的工作**：

- 无法预料的问题处理，即“救火”。包括操作事故和操作问题，通常由上述三种类型的工作导致，而且往往以牺牲其他计划内工作为代价。

## DevOps 的三个原则(三步工作法)：

1.  **Flow** 
-  团队间的流畅协作：重视整体效率，促进核心业务、开发和运维之间的流畅合作，缩短从开发到市场所需的周期。

2. **Feedback** 
- 完整的反馈回路：将市场反馈直接提供给研发团队，开发和运维团队可以根据反馈及时调整。

3. **Learning** 
- 鼓励学习和试错的文化：在个人层面上鼓励学习和提升，在公司层面上允许实验和试错。


# <a  id="summary">总结</a>

> [返回目录](#catalog)

## 参考文档：

- [这不是一本只写给IT看的IT小说 | 豆瓣 ](https://book.douban.com/review/9898756/)

- [跳出运维，才能做好运维 | 豆瓣 ](https://book.douban.com/review/9346219/)
  
- [什么是DevOps？ | UCloud云计算 - 知乎 ](https://www.zhihu.com/question/58702398/answer/1691681949)

&emsp;路漫漫其修远兮，与诸君共勉。

**后记：Hello 小伙伴们，如果觉得本文还不错，记得点个赞或者给个 star，你们的赞和 star 是我编写更多更丰富文章的动力！[GitHub 地址](https://github.com/danygitgit/document-library)**

# 文档协议

> <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/"><img alt="知识共享许可协议" style="border-width:0" src="//p3-juejin.byteimg.com/tos-cn-i-k3u1fbpfcp/c2c2a873bdad472f88ee6143620245de~tplv-k3u1fbpfcp-zoom-1.image" /></a><br /><a xmlns:dct="http://purl.org/dc/terms/" property="dct:title">**db** 的文档库</a> 由 <a xmlns:cc="http://creativecommons.org/ns#" href="db" property="cc:attributionName" rel="cc:attributionURL">db</a> 采用 <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">知识共享 署名-非商业性使用-相同方式共享 4.0 国际 许可协议</a>进行许可。<br />基于<a xmlns:dct="http://purl.org/dc/terms/" href="https://github.com/danygitgit" rel="dct:source">https://github.com/danygitgit</a>上的作品创作。<br />本许可协议授权之外的使用权限可以从 <a xmlns:cc="http://creativecommons.org/ns#" href="https://creativecommons.org/licenses/by-nc-sa/2.5/cn/" rel="cc:morePermissions">https://creativecommons.org/licenses/by-nc-sa/2.5/cn/</a> 处获得。
