@[《软技能 2：软件开发者职业生涯指南》读书笔记](https://github.com/danygitgit/document-library)

> create by **db** on **2021-1-15 20:32:30**  
> Recently revised in **2021-1-15 22:10:24**
>
> **闲时要有吃紧的心思，忙时要有悠闲的趣味**

<a id="catalog">目录</a>

- [前言](#preface)

- [主观评价](#book-evaluate)

- [内容笔记](#content-notes)

- [个人心得](#my-learning)

- [总结](#summary)

# <a  id="preface">前言</a>

> [返回目录](#catalog)

&emsp;可能是疫情影响，20 年有了更多的空闲时间，读了不少的书。一直以来，我并没有写读后感的习惯，基本上都是在书的空白处上做些笔记，写一下感悟。觉得重要些的内容就折下页，或者在扉页做摘抄。

&emsp;现在趁着机会，做下电子笔记，顺便水一篇博客，也不错。

&emsp;言归正传，作为《软技能：代码之外的生存指南》的姊妹篇，《软技能 2：软件开发者职业生涯指南》着重介绍软件工程师职业生涯，相比前者着墨于生活中的方方面面，本书更多的是介绍软件工程师职业生涯，内容贯穿了从小白到成为一个程序员的职业生涯，算是为程序员量身定做的职业发展指南，针对职场上的各项重要的“软技能”，为大家提供了较为专业的职业发展指导。

# <a  id="book-evaluate">主观评价</a>

> [返回目录](#catalog)

&emsp;《软技能 2》是一本专注于软件开发者职业发展的完整手册，从尚未入行的学生，到入行几年的老鸟，都可以从这本手册中获得一定的指导和参考。

&emsp;当然，**尽信书不如无书**，书中的建议仅仅是指导而已，具体怎么做，还是要看自己。

&emsp;能在职业开始的初期就遇到这样一本全面描绘了整个职业生涯的“地图”和“使用手册”，是很幸运的一件事。其中众多的“软技能”都是在学校、培训班中学习不到的，非常值得参考学习、实践。


&emsp;不过，作为一本方法论的书，没必要读的太细，更不需要做为教条或者圣经。


## 优点

1. **全面且详细**

- 本书详述了如何成为一名程序员并找到工作开始自己职业生涯，具体到编写简历、面试、社交、升职，并且给出了一些程序员最终发展的建议，非常的全面。

2. 延续了上一本的风格，目录详细，**字大，看起来舒服**

- 目录足足有16页！

3. 译者风格独特，行文畅快

- 就是**翻译的很好**啦，读起来很舒服

## 缺点

&emsp;首先要吐槽的是这本书太厚了，又厚又沉，一如上一本，作者面面俱到，不过有些地方讲的过于琐碎。

&emsp;其次作为一本速成书（与上一本《软技能1》仅隔两年），本书其实不如上一本内容丰富，当然也值得一读。

## 适合人群：

&emsp;这是一本针对程序员写的书，适合**在校学生**，**希望转行**程序员的小白，或者入行五年内的**初中级程序员**来读。

&emsp;小白可以学习如何开始职业生涯，老鸟也可以参考怎样优化自己的职业生涯，寻找35岁之后的出路。而对于在职程序员来说，我们瓶水面临的一些问题（比如怎样升值加薪，如何跳槽，怎样处理上下级同事关系等），本书也给出了一些建设性的意见。

&emsp;对中高级程序员，在专业技能领域本书也可以帮助检视自己的技能短板，评估自身的“天花板、是否转型管理”等问题。

&emsp;对于准备跳槽的同学来说也值得一读,其中关于**简历、面试、薪酬谈判**的章节建议阅读

&emsp;纸质书略微笨重，建议阅读电子版。


## 推荐指数：★★★★

# <a  id="content-notes">内容笔记</a>

### 本书结构

全书分为5大篇 共60章，493页

- 第一篇 入行成为软件开发者

- 第二篇 找到一份工作

- 第三篇 关于软件开发你需要知道些什么

- 第四篇 软件开发者的日常工作

- 第五篇 推进你的职业发展

&emsp;全部内容详述了从入门到大神之路。从入行简介、学习方法和途径、求职、转型、编程语言选择、软件开发类型及岗位类型、软件工程周期、同事关系、团队协作、自我营销和提升、发展人脉、知识更新、专业化、自由职业、参考书推荐等等.

<!-- ### 作者荐书

### 写出好代码的书：
设计模式
代码大全
代码整洁之道
敏捷开发：原则，模式与实践
设计模式
计算机软件测试
算法导论
企业应用架构模式
处理既有代码的书：
重构：改善既有代码
修改代码的艺术working effectively with legacy code
重构与模式
成为优秀开发者：
程序员修炼之道：从小工到专家
我编程，我快乐：程序员职业规划之道
人文类：
人性的弱点
as a man thinketh
maximum achievement: strategies and skill that will unlock your hidden power to succeed
我的人生样样稀松照样赢：How To Fail at Almost Everything and Still Win Big
娱乐类（看看就好）：
歌德，艾舍尔，巴赫-集异壁之大成：gobel，escher，bach：the eternal golden braid
magic 2.0
火星救援 The martian
雪崩 snow crash
反障碍：如何从障碍中获益 The obstacle is the way
the 10x rule
be obsessed or be average
战争的艺术：The war of art
深入挖掘的书：
编码的奥秘 code：the hidden language of computer hardware and software
计算机程序的构造和解释：structure and intercepratation of computer programs
（国外的剑指offer）程序员面试经典：cracking the code interview :150 programming questions and solutions
计算机程序设计艺术：The art of computer programming
编译原理：compilers: principles, techniques and tools -->


# <a  id="my-learning)">个人心得</a>

> [返回目录](#catalog)

**任何行动都比不采取行动好**

&emsp;任何行动往往都比没有行动好，特别是当你一直停滞在不愉快的情势下很长时间的时候。如果这是一个错误，至少你学到了一些东西。这样一来，它就不再是一个错误。如果你仍然选择停滞不前，那么你就学不到任何东西。

&emsp;在程序员的职业生涯中，没有什么比不采取行动对生产力更致命了。

&emsp;可能发生的最坏情况是什么？如果你在该做出决策的时候很纠结，你应该一直问自己这个问题。大多数时候，这个问题的答案是，你发现自己错了，转而采取其他的行动。

&emsp;通常，无所作为就像坐在一辆停着的汽车上转动方向盘。你有转过停着的汽车的方向盘吗？这并不容易。但是，当车子开起来的时候再去转方向盘就容易多了。

&emsp;最后感谢作者，向前辈学习，加油！

# <a  id="summary">总结</a>

> [返回目录](#catalog)

&emsp;路漫漫其修远兮，与诸君共勉。

**后记：Hello 小伙伴们，如果觉得本文还不错，记得点个赞或者给个 star，你们的赞和 star 是我编写更多更丰富文章的动力！[GitHub 地址](https://github.com/danygitgit/document-library)**

# 文档协议

> <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/"><img alt="知识共享许可协议" style="border-width:0" src="//p3-juejin.byteimg.com/tos-cn-i-k3u1fbpfcp/c2c2a873bdad472f88ee6143620245de~tplv-k3u1fbpfcp-zoom-1.image" /></a><br /><a xmlns:dct="http://purl.org/dc/terms/" property="dct:title">**db** 的文档库</a> 由 <a xmlns:cc="http://creativecommons.org/ns#" href="db" property="cc:attributionName" rel="cc:attributionURL">db</a> 采用 <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">知识共享 署名-非商业性使用-相同方式共享 4.0 国际 许可协议</a>进行许可。<br />基于<a xmlns:dct="http://purl.org/dc/terms/" href="https://github.com/danygitgit" rel="dct:source">https://github.com/danygitgit</a>上的作品创作。<br />本许可协议授权之外的使用权限可以从 <a xmlns:cc="http://creativecommons.org/ns#" href="https://creativecommons.org/licenses/by-nc-sa/2.5/cn/" rel="cc:morePermissions">https://creativecommons.org/licenses/by-nc-sa/2.5/cn/</a> 处获得。
